<template>
  <v-btn icon v-bind="$attrs" @click="togglePlay">
    <v-icon v-text="playIcon"/>
  </v-btn>
</template>

<script>
  export default {
    props: ['mediaId', 'media'],
    computed: {
      isActiveComponent () {
        return this.$store.state.media.id === this.mediaId
      },
      status () {
        if (this.isActiveComponent) return this.$store.state.media.status
        return 'paused'
      },
      playIcon () {
        switch (this.status) {
          case 'playing':
            return 'mdi-pause'
          case 'finished':
            return 'mdi-replay'
          default:
            return 'mdi-play'
        }
      }
    },
    methods: {
      togglePlay () {
        if (this.isActiveComponent) {
          let nextStatus
          switch (this.status) {
            case 'playing':
              nextStatus = 'paused'
              break
            case 'paused':
              nextStatus = 'playing'
              break
            case 'finished':
              nextStatus = 'playing'
              break
          }
          this.$store.commit('media/setStatus', nextStatus)
        } else {
          this.$store.dispatch('media/SetMedia', {
            file: this.media,
            id: this.mediaId,
            status: 'playing'
          })
        }
      }
    }
  }
</script>
